/*
  $Id: ParseNode.java,v 1.7 2001/06/20 09:19:23 sdw Exp $
  (c) 1996-2001 Simon Whiteside
*/

package simkin;

/**
 * ParseNode - this class is the base class for nodes in the parse tree
 * <p>The classes derived this interface within Simkin are opaque to other packages.
*/
public abstract class ParseNode {
    private int m_LineNumber=0;
    /** this method returns an integer indicating the type of the node */
    public abstract int getType();
    /** this method returns an integer indicating the line number in the source at which the item starts */
    public int getLineNumber(){
	return m_LineNumber;
    }
    protected ParseNode(int line_num){
	m_LineNumber=line_num;
    }
}





