/*
  Copyright 1996-2001
  Simon Whiteside

* $Id: StatementStepper.java,v 1.1 2001/07/05 09:54:41 sdw Exp $
*/

package simkin;
import java.util.Hashtable;

/**
 * This interface is implemented by objects which are called by the Interpreter when statements are executed
 */
public interface StatementStepper {
    /** This method is called each time a statement is executed by the interpreter, just before the statement is performed
     * @return false to halt the execution of the current method
     * @param location the location of the script
     * @param line the line the statement was on
     * @param obj the object owning the current method
     * @param local_vars the local variables for the current method
     * @param statement_type an integer indicating the type of statement, a constant s_ value from the ParseNode class
     */
    boolean statementExecuted(String location, int line_num,Object obj,Hashtable local_vars,int statement_type);
    /** This method is called each time a compound statement is executed by the interpreter, just before the statement is performed
     * @return false to halt the execution of the current method
     * @param location the location of the script
     * @param line the line the statement was on
     * @param obj the object owning the current method
     * @param local_vars the local variables for the current method
     */
    boolean compoundStatementExecuted(String location, int line_num,Object obj,Hashtable local_vars);
}
