/*
 * $Id: Tracer.java,v 1.4 2001/07/11 19:23:48 sdw Exp $
  (c) 1999 Simon Whiteside
 */

package simkin;
import java.io.PrintStream;

/**
 * This class provides an interface to System.out.println
 */
final public class Tracer {
    /**
     * This variable controls whether the output is printed to stdout or not - by default the value is true
     */
    public static boolean g_Tracing=true;
    /**
     * This variable holds the output writer, by default this is System.out
     */
    public static PrintStream g_Out=System.out;
    /**
     * This method causes the given message to be printed to g_Out (if g_Tracing is true)
     */
    public static void trace(String msg){
	if (g_Tracing)
	    g_Out.println(msg);
    }
    /**
     * This method dumps the given exception to stdout (if g_Tracing is true)
     */
    public static void trace(Exception e){
	if (g_Tracing)
	    e.printStackTrace();
	//	    e.printStackTrace(g_Out);
    }
}
