/*
  Copyright 1996-2001
  Simon Whiteside

  $Id: TreeNodeObjectEnumerator.java,v 1.5 2001/07/05 09:52:47 sdw Exp $
*/
package simkin;
import java.util.*;

/**
 * This class enumerates the elements in an TreeNodeObject 
 * 
 *
*/
public class TreeNodeObjectEnumerator implements ExecutableIterator{
    TreeNodeObject m_TreeNodeObject;
    String m_TagName="";
    int m_NodeNum=0;
    /**
     * Constructor - enumerates over every child node of this object
     */
    public TreeNodeObjectEnumerator(TreeNodeObject treeNodeObject){
	m_TreeNodeObject=treeNodeObject;
    }
    /**
     * Constructor - enumerates over children of this object with the matching tag
     */
    public TreeNodeObjectEnumerator(TreeNodeObject treeNodeObject,String tagName){
	m_TreeNodeObject=treeNodeObject;
	m_TagName=tagName;
	// first wind forward to the first occurrence of the tag
	findNextNode();
    }
    /**
     * returns the next object in the enumeration - or null if there are no more
     */
    public Object next(){
	Vector nodes=m_TreeNodeObject.getNode().getItems();
	TreeNodeObject ret=null;
	if (nodes!=null && m_NodeNum<nodes.size()){
	    TreeNode node=(TreeNode)nodes.elementAt(m_NodeNum);
	    ret=m_TreeNodeObject.createTreeNodeObject(Utils.addStrings(m_TreeNodeObject.getLocation(),".",node.label()),node);
	    if (m_TagName.length()>0)
		findNextNode();
	    else
		m_NodeNum++;
	}
	return ret;
    }
    /**
     * This method resets the enumeration to the beginning - you can now iterate over the list again
     */
    public void reset(){
	m_NodeNum=0;
	findNextNode();
    }
    /**
     * this method winds m_NodeNum onto the next matching element - or beyond the end of the list for the end of enumeration
     */
    void findNextNode(){
	Vector nodes=m_TreeNodeObject.getNode().getItems();
	if (nodes!=null)
	    for (;m_NodeNum<nodes.size();m_NodeNum++){
		TreeNode node=(TreeNode)nodes.elementAt(m_NodeNum);
		if (node.label().equals(m_TagName)){
		    break;
		}
	    }
    }
}
